# Generated by Django 2.2.17 on 2023-01-16 14:40

from django.db import migrations, models
import django.db.models.deletion
import firmware_updater_stima.models


class Migration(migrations.Migration):

    initial = True

    dependencies = [
    ]

    operations = [
        migrations.CreateModel(
            name='Name',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(default='', help_text='Firmware name', max_length=30, unique=True)),
                ('description', models.CharField(blank=True, default='', help_text='Firmware description', max_length=300)),
            ],
            options={
                'verbose_name': 'Firmware name',
                'verbose_name_plural': 'Firmware names',
                'ordering': ['name'],
            },
        ),
        migrations.CreateModel(
            name='Firmware',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('file', firmware_updater_stima.models.DeletingFileField(help_text='The firmware file to upload', max_length=255, upload_to='firmware', verbose_name='File')),
                ('version', models.PositiveIntegerField(help_text='firmware major version', verbose_name='Firmare version')),
                ('revision', models.PositiveIntegerField(help_text='firmware minor version', verbose_name='Firmare revision')),
                ('active', models.BooleanField(default=True, help_text='Activate the firmware for upgrade', verbose_name='Active')),
                ('firmware', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='firmware_updater_stima.Name')),
            ],
            options={
                'verbose_name': 'Firmware',
                'verbose_name_plural': 'Firmware',
                'ordering': ['version', 'revision'],
            },
        ),
    ]
