# Generated by Django 2.2.17 on 2023-07-11 08:57

import datetime
from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion
import ticket.models


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ('stations', '0036_auto_20230710_0909'),
    ]

    operations = [
        migrations.CreateModel(
            name='Ticket',
            fields=[
                ('ticket', models.AutoField(editable=False, primary_key=True, serialize=False)),
                ('active', models.BooleanField(default=True, help_text='Active ticket', verbose_name='Active')),
                ('date', models.DateTimeField(default=datetime.datetime.now, verbose_name='Data apertura')),
                ('priority', models.IntegerField(choices=[(1, 'Critical'), (2, 'High'), (3, 'Normal'), (4, 'Low'), (5, 'Very Low')], default=3, verbose_name='Priority')),
                ('abstract', models.CharField(max_length=40, null=True, verbose_name='Abstract of the problem')),
                ('description', models.TextField(max_length=500, verbose_name='Description of the problem')),
                ('assigned_to', models.ManyToManyField(blank=True, related_name='assigned_to', to=settings.AUTH_USER_MODEL, verbose_name='Assigned to')),
                ('stationmetadata', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='stations.StationMetadata')),
                ('subscribed_by', models.ManyToManyField(blank=True, related_name='subscribed_by', to=settings.AUTH_USER_MODEL, verbose_name='Subscribed by')),
            ],
        ),
        migrations.CreateModel(
            name='TicketImage',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('active', models.BooleanField(default=True, help_text='Activate this station image', verbose_name='Active')),
                ('description', models.TextField(blank=True, max_length=500, verbose_name='Description of the image')),
                ('date', models.DateTimeField(auto_now=True)),
                ('category', models.CharField(choices=[('station', 'Station description'), ('sensors', 'Sensors description'), ('others', 'Others')], max_length=50)),
                ('image', ticket.models.DeletingImageField(upload_to='ticketimage')),
                ('ticket', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='ticket.Ticket')),
            ],
        ),
        migrations.CreateModel(
            name='TicketAttachment',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('active', models.BooleanField(default=True, help_text='Activate this station image', verbose_name='Active')),
                ('date', models.DateTimeField(auto_now=True)),
                ('file', models.FileField(max_length=1000, upload_to='tickets_attachments', validators=[ticket.models.validate_file_extension], verbose_name='File')),
                ('filename', models.CharField(blank=True, max_length=1000, verbose_name='Filename')),
                ('mime_type', models.CharField(blank=True, max_length=255, verbose_name='MIME Type')),
                ('size', models.IntegerField(blank=True, help_text='Size of this file in bytes', verbose_name='Size')),
                ('ticket', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='ticket.Ticket')),
            ],
            options={
                'verbose_name': 'Attachment',
                'verbose_name_plural': 'Attachments',
                'ordering': ('filename',),
            },
        ),
        migrations.CreateModel(
            name='TicketAction',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('active', models.BooleanField(default=True, help_text='Activate this action', verbose_name='Active')),
                ('date', models.DateTimeField(default=datetime.datetime.now, verbose_name='Date and time')),
                ('category', models.CharField(choices=[('onsite', 'Action on site'), ('remote', 'Action fron remote'), ('server', 'Action on server'), ('others', 'Others')], max_length=50)),
                ('description', models.TextField(blank=True, max_length=500, verbose_name='Description of the action')),
                ('ticket', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='ticket.Ticket')),
            ],
        ),
    ]
